%This script is used to generate simulation plots for no-fading case%
clear all;
v_ue_sim_kmh = [3 30 60 120];
v_ue_sim_ms = v_ue_sim_kmh*(1000/3600);
tm = 80e-3;
tpp=1;
T_d = [40e-3, 20e-3, 10e-3];
rm = 50;
rp = 78;
R = 64;
div=2500;
theta_p=linspace(0,2*pi,div);
theta_mue_hf=linspace(0,2*pi,div);
theta_pue_hf=linspace(0,2*pi,div);
X_p=R*cos(theta_p);
Y_p=R*sin(theta_p);
X_mue_hf=rm*cos(theta_mue_hf);
Y_mue_hf=rm*sin(theta_mue_hf);
X_pue_hf=rp*cos(theta_pue_hf);
Y_pue_hf=rp*sin(theta_pue_hf);
center_x_p=R;
center_y_p=R;
center_x_mue_hf=R;
center_y_mue_hf=R;
center_x_pue_hf=R;
center_y_pue_hf=R;
X_p=X_p+center_x_p;
Y_p=Y_p+center_y_p;
X_mue_hf=X_mue_hf+center_x_mue_hf;
Y_mue_hf=Y_mue_hf+center_y_mue_hf;
X_pue_hf=X_pue_hf+center_x_pue_hf;
Y_pue_hf=Y_pue_hf+center_y_pue_hf;
alpha_ue=linspace(0,pi/2,500);
num_r_dist=500;
%plotting the mesh grid of hf and pico circle%
% plot(X_pue_hf,Y_pue_hf,'y',X_p,Y_p,'g',X_mue_hf,Y_mue_hf,'r');
    for i=1:length(T_d)
        i
        mue_hf=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        nhf=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        pue_hf=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        ho=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        pp=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        x_ue1=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));%initial position (co-ordinates) of the user
        y_ue1=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        y_ue1(:,:,:)=R;
        x_ue2=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        y_ue2=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        x_ue3=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        y_ue3=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        x_ue4=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        y_ue4=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        x_ue5=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        y_ue5=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        x_ue6=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
        y_ue6=zeros(length(alpha_ue),num_r_dist,length(v_ue_sim_ms));
%         plot(X_pue_hf,Y_pue_hf,'y',X_p,Y_p,'g',X_mue_hf,Y_mue_hf,'r');
%         hold on;
        for k=1:length(v_ue_sim_ms)
            v=v_ue_sim_ms(k);
            for j=1:length(alpha_ue)
                ue_angle=alpha_ue(j);
                r_dist=linspace(0,v*T_d(i),num_r_dist);
%                 r_dist_p = datasample(r_dist,num_r_dist,'Replace',false);
                r_dist_p = r_dist;
                for m=1:num_r_dist
                    x_ue2(j,m,k)=x_ue1(j,m,k)+r_dist(m)*cos(ue_angle);
                    y_ue2(j,m,k)=y_ue1(j,m,k)+r_dist(m)*sin(ue_angle);
                    x_ue3(j,m,k)=x_ue2(j,m,k)+v*tm*cos(ue_angle);
                    y_ue3(j,m,k)=y_ue2(j,m,k)+v*tm*sin(ue_angle);
%                     plot(x_ue3(j,m,k),y_ue3(j,m,k),'^');
%                     plot(x_ue2(j,m,k),y_ue2(j,m,k),'ko');
%                     plot(x_ue1(j,m,k),y_ue1(j,m,k),'r*');
%                     pause(0.1);
                    dist_mue_hf_td=sqrt((x_ue3(j,m,k)-center_x_mue_hf)^2+(y_ue3(j,m,k)-center_y_mue_hf)^2);% to calculate hf
                    dist_pico_td=sqrt((x_ue3(j,m,k)-center_x_p)^2+(y_ue3(j,m,k)-center_y_p)^2);
                    mue_traj = [x_ue1(j,m,k),y_ue1(j,m,k);x_ue3(j,m,k),y_ue3(j,m,k)];
                    [mue_hf_intersect_x,mue_hf_intersect_y] = polyxpoly1(X_mue_hf,Y_mue_hf,mue_traj(:,1),mue_traj(:,2));
                    if(roundn1(dist_mue_hf_td,-10)<=roundn1(rm,-10))
                        mue_hf(j,m,k)=1;
                    else
                        mue_hf(j,m,k)=0;
                    end
                    if(~isempty(mue_hf_intersect_x))
                        mue_hf(j,m,k) = 1;
                    else
                        mue_hf(j,m,k)=0;
                    end
                    if(roundn1(dist_pico_td,-10)>roundn1(R,-10)&&mue_hf(j,m,k)==0)
                        nhf(j,m,k)=1;
                        ho(j,m,k)=0;
                    elseif(roundn1(dist_pico_td,-10)<=roundn1(R,-10)&&mue_hf(j,m,k)==0)
                        nhf(j,m,k)=0;
                        ho(j,m,k)=1;
                    else
                        ho(j,m,k)=0;
                    end
                    if(roundn1(dist_pico_td,-10)<roundn1(R,-10)&&ho(j,m,k)==1)
                        dist_ue=sqrt((x_ue3(j,m,k)-x_ue1(j,m,k))^2+(y_ue3(j,m,k)-y_ue1(j,m,k))^2);
                        d_alpha=cos(ue_angle)*2*R;
                        x_pico_bound=x_ue3(j,m,k)+roundn1((d_alpha-dist_ue),-10)*cos(ue_angle);
                        y_pico_bound=y_ue3(j,m,k)+roundn1((d_alpha-dist_ue),-10)*sin(ue_angle);
                        x_ue4(j,m,k)=x_pico_bound+r_dist_p(m)*cos(ue_angle);
                        y_ue4(j,m,k)=y_pico_bound+r_dist_p(m)*sin(ue_angle);
                        x_ue5(j,m,k)=x_ue4(j,m,k)+v*tm*cos(ue_angle);
                        y_ue5(j,m,k)=y_ue4(j,m,k)+v*tm*sin(ue_angle);
%                         plot(x_pico_bound,y_pico_bound,'*');
%                         plot(x_ue4(j,m,k),y_ue4(j,m,k),'o');
%                         plot(x_ue5(j,m,k),y_ue5(j,m,k),'^');
%                         pause(0.1);
                        dist_pue_hf_td=sqrt((x_ue5(j,m,k)-center_x_pue_hf)^2+(y_ue5(j,m,k)-center_y_pue_hf)^2);% to calculate hf
                        dist_pp_check=sqrt((x_ue3(j,m,k)-x_ue5(j,m,k))^2+(y_ue3(j,m,k)-y_ue5(j,m,k))^2);% to calculate hf
                        if(dist_pue_hf_td>=rp)
                            pue_hf(j,m,k)=1;
                        elseif(dist_pue_hf_td<rp)
                            pue_hf(j,m,k)=0;
                        end
                        if(roundn1(dist_pp_check,-10)<=roundn1(v*tpp,-10)&&pue_hf(j,m,k)==0)
                            pp(j,m,k)=1;
                        else
                            pp(j,m,k)=0;
                        end
                    else
                        pue_hf(j,m,k)=0;
                        pp(j,m,k)=0;
                    end
                end
            end
            temp(k,:)=sum(nhf(:,:,k),2)./num_r_dist;
            temp1(k)=sum(temp(k,:))/length(alpha_ue);
            prob_nho(i,k)=temp1(k);
            temp2(k,:)=sum(mue_hf(:,:,k),2)./num_r_dist;
            temp3(k)=sum(temp2(k,:))/length(alpha_ue);
            prob_mue_hf(i,k)=temp3(k);
            temp4(k,:)=sum(pue_hf(:,:,k),2)./num_r_dist;
            temp5(k)=sum(temp4(k,:))/length(alpha_ue);
            prob_pue_hf(i,k)=temp5(k);
            temp6(k,:)=sum(pp(:,:,k),2)./num_r_dist;
            temp7(k)=sum(temp6(k,:))/length(alpha_ue);
            prob_pp(i,k)=temp7(k);
        end
    end
% prob_nho= [zeros(1,length(T_d))' prob_nho];
% prob_mue_hf= [zeros(1,length(T_d))' prob_mue_hf];
% prob_pue_hf=[zeros(1,length(T_d))' prob_pue_hf];
% prob_pp=[zeros(1,length(T_d))' prob_pp];
figure;
plot(v_ue_sim_kmh,prob_nho(1,:),v_ue_sim_kmh,prob_nho(2,:),v_ue_sim_kmh,prob_nho(3,:));
xlabel('velocity(km/hour)');
ylabel('No Handover failure probability');
% title(['Pico radius (R)=',num2str(R*1000),'m',scenario{idx}]);
% legend(['T_d = ',num2str(L1(1)*5),' ms'],['T_d = ',num2str(L1(2)*5),' ms'],['T_d = ',num2str(L1(3)*5),' ms']);
figure;
plot(v_ue_sim_kmh,prob_mue_hf(1,:),v_ue_sim_kmh,prob_mue_hf(2,:),v_ue_sim_kmh,prob_mue_hf(3,:));
xlabel('velocity(km/hour)');
ylabel('MUE Handover failure probability');
% title(['Pico radius (R)=',num2str(R*1000),'m']);
% legend(['T_d = ',num2str(L1(1)*5),' ms'],['T_d = ',num2str(L1(2)*5),' ms'],['T_d = ',num2str(L1(3)*5),' ms']);
figure;
plot(v_ue_sim_kmh,prob_pue_hf(1,:),v_ue_sim_kmh,prob_pue_hf(2,:),v_ue_sim_kmh,prob_pue_hf(3,:));
xlabel('velocity(km/hour)');
ylabel('PUE Handover failure probability');
% title(['Pico radius (R)=',num2str(R*1000),'m']);
% legend(['T_d = ',num2str(L1(1)*5),' ms'],['T_d = ',num2str(L1(2)*5),' ms'],['T_d = ',num2str(L1(3)*5),' ms']);
% save(['all_res2' scenario{idx}], 'prob_mue_hf' ,'prob_pue_hf', 'prob_nho', 'prob_pp', 'v_ue_sim_kmh')
% figure;
% plot(v_ue_sim_kmh,prob_pp(1,:),v_ue_sim_kmh,prob_pp(2,:),v_ue_sim_kmh,prob_pp(3,:),v_ue_sim_kmh,prob_pp(4,:));
% xlabel('velocity(km/hour)');
% ylabel('Ping-Pong probability');
% title(['Pico radius (R)=',num2str(R*1000),'m']);
% legend(['T_d = ',num2str(T_d(1)*1e3),' ms'],['T_d = ',num2str(T_d(2)*1e3),' ms'],['T_d = ',num2str(T_d(3)*1e3),' ms'],['T_d = ',num2str(T_d(4)*1e3),' ms']);
% figure;
% plot(v_ue,prob_pp(1,:),v_ue,prob_pp(2,:),v_ue,prob_pp(3,:),v_ue,prob_pp(4,:));
% xlabel('velocity(km/hour)');
% ylabel('Ping-Pong probability');
% title(['Pico radius (R)=',num2str(R*1000),'m']);
% legend(['T_d = ',num2str(T_d(1)*3600*1e3),' ms (Sim)'],['T_d = ',num2str(T_d(2)*3600*1e3),' ms (Sim)'],['T_d = ',num2str(T_d(3)*3600*1e3),' ms (Sim)'],['T_d = ',num2str(T_d(4)*3600*1e3),' ms (Sim)']);
% figure;
% plot(v_ue,prob_nho(1,:),'rd','MarkerSize',6,'LineWidth',2);
% plot(v_ue,prob_nho(2,:),'go','MarkerSize',6,'LineWidth',2);
% plot(v_ue,prob_nho(3,:),'b*','MarkerSize',6,'LineWidth',2);
% plot(v_ue,prob_nho(4,:),'m^','MarkerSize',6,'LineWidth',2);
% xlabel('velocity(km/hour)');
% ylabel('No handover probability');
% title(['Pico radius (R)=',num2str(R*1000),'m']);
% legend(['T_d = ',num2str(T_d(1)*3600*1e3),' ms (Sim)'],['T_d = ',num2str(T_d(2)*3600*1e3),' ms (Sim)'],['T_d = ',num2str(T_d(3)*3600*1e3),' ms (Sim)'],['T_d = ',num2str(T_d(4)*3600*1e3),' ms (Sim)']);
% figure;
% plot(v_ue,prob_mue_hf(1,:),v_ue,prob_mue_hf(2,:),v_ue,prob_mue_hf(3,:),v_ue,prob_mue_hf(4,:));
% xlabel('velocity(km/hour)');
% ylabel('MUE Handover Failure probability');
% title(['Pico radius (R)=',num2str(R*1000),'m']);
% legend(['T_d = ',num2str(T_d(1)*3600*1e3),' ms (Sim)'],['T_d =
% ',num2str(T_d(2)*3600*1e3),' ms (Sim)'],['T_d =
% ',num2str(T_d(3)*3600*1e3),' ms (Sim)'],['T_d = ',num2str(T_d(4)*3600*1e3),' ms (Sim)']);