%This function is used to generate theoretical MUE HF plots for no-fading case

function[]= prob_td_muehf_latest()
% R=21.76/1000;
R=64;
v_km=linspace(0,120,30);
v=v_km*(1000/3600);
rm=50;
%TTT=[480e-3/3600,160e-3/3600,80e-3/3600,40e-3/3600];
tm=480e-3;
T_d=[40e-3,20e-3,10e-3];
prob_hf_m=zeros(1,size(v,2));
% prob_hf_m1=zeros(1,size(v,2));
% prob_hf_m2=zeros(1,size(v,2));
for j=1:size(T_d,2)
    td=T_d(j);
    for i=1:size(v,2)
        vel_tm=v(i)*tm;
        vel_td=v(i)*td;
        if(vel_tm==0)
            prob_hf_m(i)=0;
        elseif(vel_tm+vel_td<=(R-rm))
            prob_hf_m(i)=0;
        elseif(vel_tm>=sqrt(R^2-rm^2))
            prob_hf_m(i)=(2/pi)*atan(rm/sqrt(R^2-rm^2));
        elseif(vel_tm+vel_td>(R-rm)&&vel_tm+vel_td<=sqrt(R^2-rm^2))
            int_val1=quadgk(@(rd) my_muehf8(R,rm,vel_tm,rd),0,vel_td);
            d_alpha1_no_rd=((R^2-rm^2)./(vel_tm))+(vel_tm);
            t_3=(2/pi)*(atan(2*sqrt(R^2-(d_alpha1_no_rd^2/4))/d_alpha1_no_rd));
            alpha_limit=acos((R^2+(vel_tm)^2-rm^2)/(2*R*(vel_tm)));
            int_val2=quad(@(rd) my_muehf7(R,rm,vel_tm,rd),0,vel_td);
            if(vel_td==0)
                prob_hf_m(i)=(alpha_limit/asin(rm/R))*(2/pi)*atan(rm/sqrt(R^2-rm^2));
            elseif(d_alpha1_no_rd>2*R)
                int_val2=quadgk(@(rd) my_muehf8(R,rm,vel_tm,rd),R-rm-vel_tm,vel_td);
                t2 = (2/(pi*vel_td))*int_val2;
                t1 = (1/vel_td)*(vel_td-(R-rm-vel_tm));
                prob_hf_m(i) = t1-t2;
            elseif(d_alpha1_no_rd<2*R)
                %prob_hf_m2=int_val2/(vel_td*asin(rm/R));
                prob_hf_m(i) = 1-(2/(pi*vel_td))*int_val1;
            else
                prob_hf_m(i) = 0;
            end
        elseif(vel_tm+vel_td>=sqrt(R^2-rm^2))  
            int_val1=quadgk(@(rd) my_muehf8(R,rm,vel_tm,rd),0,vel_td);
            d_alpha1_no_rd=((R^2-rm^2)./(vel_tm))+(vel_tm);
            d_alpha1_td=((R^2-rm^2)./(vel_tm+vel_td))+(vel_tm+vel_td);
            t_3=(2/pi)*(atan(2*sqrt(R^2-(d_alpha1_no_rd^2/4))/d_alpha1_no_rd));
            alpha_limit=acos((R^2+(vel_tm)^2-rm^2)/(2*R*(vel_tm)));
            int_val2=quadgk(@(rd) my_muehf7(R,rm,vel_tm,rd),0,vel_td);
            t_4 = (1/vel_td)*(R-rm-vel_tm);
            if(vel_td==0)
                prob_hf_m(i)=(alpha_limit/asin(rm/R))*(2/pi)*atan(rm/sqrt(R^2-rm^2));
            elseif(d_alpha1_no_rd <= 2*sqrt(R^2-rm^2)) 
                prob_hf_m(i) = 1 - (2/pi)*atan(sqrt(R^2-rm^2)/rm);
            else
                prob_hf_m(i) = 1-(2/(pi*vel_td))*int_val2;
            end
        else
            prob_hf_m(i)=0;
        end
    end
prob_hf_m_set(j,:)=prob_hf_m;
end
%figure;
%plot(v,prob_nh_set(1,:),v,prob_nh_set(2,:),v,prob_nh_set(3,:),v,prob_nh_set(4,:));
%title('probability of NHO');
%legend('td=50ms','td=100ms','td=150ms','td=200ms');
figure;
plot(v_km,prob_hf_m_set(1,:),v_km,prob_hf_m_set(2,:),v_km,prob_hf_m_set(3,:));
% grid on;
% axis([0 120 0 0.5]);
xlabel('Velocity (km/hour)');
ylabel('Handover Failure Probability');
%title(['MUE HF probability for R=',num2str(R*1000),'mm, rm=',num2str(rm*1000),'mm and Tm=',num2str(tm*3600*1e3),'ms']);
legend(['T_d = ',num2str(T_d(1)*1e3),' ms'],['T_d = ',num2str(T_d(2)*1e3),' ms'],['T_d = ',num2str(T_d(3)*1e3),' ms']);
end