%This function is used to generate theoretical PUE HF plots for no-fading case
function[prob_hf_p_set]= prob_td_pue_hf_latest()
% warning('off')
% dbstop if error
% R=21.76/1000;
R=64;
%v=0:120;
v = linspace(0,120,30)*(1000/3600);
v_km = linspace(0,120,30);
% v = [3 30 60 120] ;
rm=50;
rp=78;
%TTT=[480e-3/3600,160e-3/3600,80e-3/3600,40e-3/3600];
tm=480e-3;
tp=480e-3;
Tpp=1;
T_d=[40e-3,20e-3,10e-3];
prob_hf_p=zeros(1,length(v));
%prob_pp=zeros(1,length(v));
for j=1:length(T_d)
    td=T_d(j);
    for i=1:length(v)
        vel_tm=v(i)*tm;
        vel_tp=v(i)*tp;
        vel_td=v(i)*td;
        if(vel_tm==0)
            prob_hf_p(i)=0;
            %prob_pp(i)=0;
        elseif(vel_tm+vel_td>sqrt(R^2-rm^2)&&vel_tm+vel_td<=2*sqrt(R^2-rm^2))
            if(vel_tp+vel_td>=sqrt(rp^2-rm^2)-sqrt(R^2-rm^2))
%                 rd_limit = (-3*vel_tp-vel_tm+sqrt((vel_tp-vel_tm)^2-8*(rp^2+R^2)))/4;
                d_vel_tm_td = vel_tm+vel_td;
                drp_end_td = ((rp^2-R^2)/(vel_tp + vel_td))-(vel_tp + vel_td);
                drp_end_no_td = ((rp^2-R^2)/(vel_tp))-(vel_tp);
                cond_d_vel_tmtd_max = vel_tm > drp_end_no_td; %condition to check the interval which is maximum when they dont overlap%
                cond_d_rp_max = d_vel_tm_td < drp_end_td;
                interv_ovlap = (vel_tm < drp_end_no_td) && (d_vel_tm_td > drp_end_td); %condition to check if two intervals overlap%
                if(interv_ovlap)
                    rd_limit = (sqrt(-8*R^2+8*rp^2+vel_tm^2-2*vel_tm*vel_tp+vel_tp^2)-3*vel_tp-vel_tm)/4;
                    t1 = (2/pi)*atan(sqrt(R^2-rm^2)/rm);
                    integral_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,rd_limit);
                    t2 = (2/(pi*vel_td))*integral_1;
                    t3_1 = (2/(pi*vel_td))*(sqrt(4*R^2-(vel_tm+vel_td)^2));
                    t3_2 = (2/(pi*vel_td))*((vel_tm+vel_td)*atan((vel_tm+vel_td)/(sqrt(4*R^2-(vel_tm+vel_td)^2))));
                    t4_1 = (2/(pi*vel_td))*(sqrt(4*R^2-(vel_tm+rd_limit)^2));
                    t4_2 = (2/(pi*vel_td))*((vel_tm+rd_limit)*atan((vel_tm+rd_limit)/(sqrt(4*R^2-(vel_tm+rd_limit)^2))));
                    prob_hf_p(i) = t1 - t2 - t3_1 - t3_2 + t4_1 + t4_2;
                elseif(~interv_ovlap)
                    if(cond_d_rp_max&&drp_end_no_td<2*R)
                        t1 = (2/pi)*atan(sqrt(R^2-rm^2)/rm);
                        integral_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,vel_td);
                        t2 = (2/(pi*vel_td))*integral_1;
                         prob_hf_p(i) = t1 - t2;
                    else
                        t1 = (2/pi)*atan(sqrt(R^2-rm^2)/rm);
                        t3_1 = (2/(pi*vel_td))*(sqrt(4*R^2-(vel_tm+vel_td)^2));
                        t3_2 = (2/(pi*vel_td))*((vel_tm+vel_td)*atan((vel_tm+vel_td)/(sqrt(4*R^2-(vel_tm+vel_td)^2))));
                        t4_1 = (2/(pi*vel_td))*(sqrt(4*R^2-(vel_tm)^2));
                        t4_2 = (2/(pi*vel_td))*((vel_tm)*atan((vel_tm)/(sqrt(4*R^2-(vel_tm)^2))));
                        prob_hf_p(i) = t1 - t3_1 - t3_2 + t4_1 + t4_2;
                    end
                else
                    prob_hf_p(i) = 0;
                end
            else
                hi = 1;
            end
        elseif(vel_tm+vel_td<=sqrt(R^2-rm^2))
            if(vel_tp+vel_td>=sqrt(rp^2-rm^2)-sqrt(R^2-rm^2))
                d_vel_tm_td = vel_tm+vel_td;
                drm_end_td = ((R^2-rm^2)/(vel_tm+vel_td))+(vel_tm+vel_td);
                drm_end_no_td = ((R^2-rm^2)/(vel_tm))+(vel_tm);
                drp_end_td = ((rp^2-R^2)/(vel_tp + vel_td))-(vel_tp + vel_td);
                drp_end_no_td = ((rp^2-R^2)/(vel_tp))-(vel_tp);
                cond_d_rm_max = drm_end_td > drp_end_no_td;
                cond_d_rp_max = drm_end_no_td < drp_end_td;
                interv_ovlap = (drm_end_td < drp_end_no_td) && (drm_end_no_td > drp_end_td);
                % to check if vel_tm_td regions overlap with d_rp_regions%
                cond_d_vel_tmtd_max = vel_tm > drp_end_no_td;
                cond_d_rp_max1 = d_vel_tm_td < drp_end_td;
                interv_ovlap1 = (vel_tm < drp_end_no_td) && (d_vel_tm_td > drp_end_td);
                if(cond_d_rp_max1 && drp_end_no_td>2*R && drm_end_no_td>2*R && interv_ovlap)
                    rd_limit_dp_td = -(2*vel_td*vel_tm + 2*vel_td*vel_tp + 2*vel_tm*vel_tp - (R^4 - 2*R^2*rm^2 - 2*R^2*vel_td^2 - 4*R^2*vel_td*vel_tm - 2*R^2*vel_tm^2 + rm^4 - 2*rm^2*vel_td^2 - 4*rm^2*vel_td*vel_tm - 2*rm^2*vel_tm^2 + 4*rp^2*vel_td^2 + 8*rp^2*vel_td*vel_tm + 4*rp^2*vel_tm^2 + vel_td^4 + 4*vel_td^3*vel_tm + 6*vel_td^2*vel_tm^2 + 4*vel_td*vel_tm^3 + vel_tm^4)^(1/2) + R^2 - rm^2 + vel_td^2 + vel_tm^2)/(2*(vel_td + vel_tm));
                    integ_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),rd_limit_dp_td,vel_td);
                    t1 = (2/(pi*vel_td))*integ_1;
                    t2 = (2/(pi*vel_td))*atan(drp_end_td/sqrt(4*R^2-drp_end_td^2))*(vel_td-rd_limit_dp_td);
                    integ_2 = quad(@(rd) my_puehf3(R,rm,vel_tm,rd),R-rm-vel_tm,vel_td);
                    t3 = (2/(pi*vel_td))*integ_2;
                    t5 = (2/(pi*vel_td))*atan(drm_end_td/sqrt(4*R^2-drm_end_td^2))*(vel_td-(R-rm-vel_tm));
                    prob_hf_p(i) = t1-t2+t3-t5;
                elseif(cond_d_rp_max1 && drp_end_no_td>2*R && drm_end_td>2*R && ~interv_ovlap)
                    integ_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),rp-R-vel_tp,vel_td);
                    t1 = (2/(pi*vel_td))*integ_1;
                    t2 = (1/vel_td)*(vel_td-(rp-R-vel_tp));
                    prob_hf_p(i) = t2-t1;
                elseif(cond_d_rp_max1 && drp_end_no_td<2*R && drm_end_td<2*R && drm_end_no_td>2*R && ~interv_ovlap && ~interv_ovlap1)
                    integ_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,vel_td);
                    t1 = (2/(pi*vel_td))*integ_1;
                    integ_2 = quad(@(rd) my_puehf3(R,rm,vel_tm,rd),R-rm-vel_tm,vel_td);
                    t2 = (2/(pi*vel_td))*integ_2;
                    t3 = (1/vel_td)*(R-rm-vel_tm);
                    prob_hf_p(i) = t3+t2-t1;
                elseif(drp_end_no_td<2*R && drm_end_td<2*R && drm_end_no_td>2*R && ~interv_ovlap && interv_ovlap1)
                    rd_limit = (sqrt(-8*R^2+8*rp^2+vel_tm^2-2*vel_tm*vel_tp+vel_tp^2)-3*vel_tp-vel_tm)/4;
                    integ_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,rd_limit);
                    t1 = (2/(pi*vel_td))*integ_1;
                    integ_2 = quad(@(rd) mynho5(R,vel_tm,rd),rd_limit,vel_td);
                    t2 = (2/(pi*vel_td))*integ_2;
                    integ_3 = quad(@(rd) my_puehf3(R,rm,vel_tm,rd),R-rm-vel_tm,vel_td);
                    t3 = (2/(pi*vel_td))*integ_3;
                    t4 = (1/vel_td)*(R-rm-vel_tm);
                    prob_hf_p(i) = t4+t3-t1-t2;
                elseif(cond_d_rp_max1 && drm_end_td>2*R && drp_end_no_td<2*R && ~interv_ovlap)
                    integ_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,vel_td);
                    t1 = (2/(pi*vel_td))*integ_1;
%                     t2 = (2/pi)*atan(drp_end_td/sqrt(4*R^2-drp_end_td^2));
%                     t3 = (2/pi)*atan(drp_end_no_td/sqrt(4*R^2-drp_end_no_td^2));
                    prob_hf_p(i) = 1-t1;
                elseif(cond_d_rp_max1 && drp_end_no_td>2*R && drm_end_no_td<2*R && interv_ovlap)
                    rd_limit_dp_td = -(2*vel_td*vel_tm + 2*vel_td*vel_tp + 2*vel_tm*vel_tp - (R^4 - 2*R^2*rm^2 - 2*R^2*vel_td^2 - 4*R^2*vel_td*vel_tm - 2*R^2*vel_tm^2 + rm^4 - 2*rm^2*vel_td^2 - 4*rm^2*vel_td*vel_tm - 2*rm^2*vel_tm^2 + 4*rp^2*vel_td^2 + 8*rp^2*vel_td*vel_tm + 4*rp^2*vel_tm^2 + vel_td^4 + 4*vel_td^3*vel_tm + 6*vel_td^2*vel_tm^2 + 4*vel_td*vel_tm^3 + vel_tm^4)^(1/2) + R^2 - rm^2 + vel_td^2 + vel_tm^2)/(2*(vel_td + vel_tm));
                    integ_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),rd_limit_dp_td,vel_td);
                    t1 = (2/(pi*vel_td))*integ_1;
                    t2 = (2/(pi*vel_td))*atan(drp_end_td/sqrt(4*R^2-drp_end_td^2))*(vel_td-rd_limit_dp_td);
                    integ_2 = quad(@(rd) my_puehf3(R,rm,vel_tm,rd),0,vel_td);
                    t3 = (2/(pi*vel_td))*integ_2;
                    integ_3 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,rd_limit_dp_td);
                    t4 = (2/(pi*vel_td))*integ_3;
                    t5 = (2/pi)*atan(drm_end_td/sqrt(4*R^2-drm_end_td^2));
                    prob_hf_p(i) = t1-t2+t3-t5;
                elseif(cond_d_rp_max1 && drm_end_no_td<2*R && drp_end_no_td<2*R && interv_ovlap)
                     rd_limit_dp_td = -(2*vel_td*vel_tm + 2*vel_td*vel_tp + 2*vel_tm*vel_tp - (R^4 - 2*R^2*rm^2 - 2*R^2*vel_td^2 - 4*R^2*vel_td*vel_tm - 2*R^2*vel_tm^2 + rm^4 - 2*rm^2*vel_td^2 - 4*rm^2*vel_td*vel_tm - 2*rm^2*vel_tm^2 + 4*rp^2*vel_td^2 + 8*rp^2*vel_td*vel_tm + 4*rp^2*vel_tm^2 + vel_td^4 + 4*vel_td^3*vel_tm + 6*vel_td^2*vel_tm^2 + 4*vel_td*vel_tm^3 + vel_tm^4)^(1/2) + R^2 - rm^2 + vel_td^2 + vel_tm^2)/(2*(vel_td + vel_tm));
                     rd_limit_tang = sqrt(rp^2-rm^2)-sqrt(R^2-rm^2)-vel_tp;
                     integ_1 = quad(@(rd) my_puehf3(R,rm,vel_tm,rd),0,vel_td);
                     t1 = (2/(pi*vel_td))*integ_1;
                     integ_2 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,vel_td);
                     t2 = (2/(pi*vel_td))*integ_2;
                     integ_3 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,rd_limit_dp_td);
                     t3 = (2/(pi*vel_td))*integ_3;
                     t4 = (2/(pi*vel_td))*atan(drp_end_no_td/sqrt(4*R^2-drp_end_no_td^2))*(rd_limit_dp_td);
    %                      t3_1 = (2/(pi*vel_td))*(sqrt(4*R^2-(vel_tm+vel_td)^2));
    %                      t3_2 = (2/(pi*vel_td))*((vel_tm+vel_td)*atan((vel_tm+vel_td)/(sqrt(4*R^2-(vel_tm+vel_td)^2))));
    %                      t4_1 = (2/(pi*vel_td))*(sqrt(4*R^2-(vel_tm+rd_limit_2)^2));
    %                      t4_2 = (2/(pi*vel_td))*((vel_tm+rd_limit_2)*atan((vel_tm+rd_limit_2)/(sqrt(4*R^2-(vel_tm+rd_limit_2)^2))));
                     prob_hf_p(i) = t1-t2;
                elseif(cond_d_rp_max1 && drm_end_no_td<2*R && drp_end_no_td<2*R && ~interv_ovlap && ~interv_ovlap1)
                     integ_1 = quad(@(rd) my_puehf3(R,rm,vel_tm,rd),0,vel_td);
                     t1 = (2/(pi*vel_td))*integ_1;
                     integ_2 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,vel_td);
                     t2 = (2/(pi*vel_td))*integ_2;
                     prob_hf_p(i) = t1-t2;
                elseif(cond_d_rp_max1 && drm_end_no_td<2*R && drp_end_no_td<2*R && interv_ovlap1)
                    rd_limit = (sqrt(-8*R^2+8*rp^2+vel_tm^2-2*vel_tm*vel_tp+vel_tp^2)-3*vel_tp-vel_tm)/4;
                    integ_1 = quad(@(rd) my_puehf3(R,rm,vel_tm,rd),0,vel_td);
                    t1 = (2/(pi*vel_td))*integ_1;
                    integral_2 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,rd_limit);
                    t2 = (2/(pi*vel_td))*integral_2;
                    t3_1 = (2/(pi*vel_td))*(sqrt(4*R^2-(vel_tm+vel_td)^2));
                    t3_2 = (2/(pi*vel_td))*((vel_tm+vel_td)*atan((vel_tm+vel_td)/(sqrt(4*R^2-(vel_tm+vel_td)^2))));
                    t4_1 = (2/(pi*vel_td))*(sqrt(4*R^2-(vel_tm+rd_limit)^2));
                    t4_2 = (2/(pi*vel_td))*((vel_tm+rd_limit)*atan((vel_tm+rd_limit)/(sqrt(4*R^2-(vel_tm+rd_limit)^2))));
                    prob_hf_p(i) = t1 - t2 - t3_1 - t3_2 + t4_1 + t4_2;
                elseif(cond_d_vel_tmtd_max && drp_end_no_td<2*R && drm_end_td<2*R && drm_end_no_td<2*R && ~interv_ovlap1 && ~interv_ovlap)
                    integ_1 = quad(@(rd) mynho5(R,vel_tm,rd),0,vel_td);
                    t1 = (2/(pi*vel_td))*integ_1;
                    integ_2 = quad(@(rd) my_puehf3(R,rm,vel_tm,rd),0,vel_td);
                    t2 = (2/(pi*vel_td))*integ_2;
                    prob_hf_p(i) = t2-t1;
                elseif(drp_end_no_td<2*R && drm_end_td<2*R && drm_end_no_td<2*R && interv_ovlap1)
                    rd_limit = (sqrt(-8*R^2+8*rp^2+vel_tm^2-2*vel_tm*vel_tp+vel_tp^2)-3*vel_tp-vel_tm)/4;
                    integ_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,rd_limit);
                    t1 = (2/(pi*vel_td))*integ_1;
                    integ_2 = quad(@(rd) mynho5(R,vel_tm,rd),rd_limit,vel_td);
                    t2 = (2/(pi*vel_td))*integ_2;
                    integ_3 = quad(@(rd) my_puehf3(R,rm,vel_tm,rd),0,vel_td);
                    t3 = (2/(pi*vel_td))*integ_3;
                    prob_hf_p(i) = t3-t2-t1;
                else
                    prob_hf_p(i) = 0;
                end
            else
                d_vel_tm_td = vel_tm+vel_td;
                drm_end_td = ((R^2-rm^2)/(vel_tm+vel_td))+(vel_tm+vel_td);
                drm_end_no_td = ((R^2-rm^2)/(vel_tm))+(vel_tm);
                drp_end_td = ((rp^2-R^2)/(vel_tp + vel_td))-(vel_tp + vel_td);
                drp_end_no_td = ((rp^2-R^2)/(vel_tp))-(vel_tp);
                cond_d_rm_max = drm_end_td > drp_end_no_td;
                cond_d_rp_max = drm_end_no_td < drp_end_td;
                interv_ovlap = (drm_end_td < drp_end_no_td) && (drm_end_no_td > drp_end_td);
                % to checlk if vel_tm_td regions overlap with d_rp_regions%
                cond_d_vel_tmtd_max = vel_tm > drp_end_no_td;
                cond_d_rp_max1 = d_vel_tm_td < drp_end_td;
                interv_ovlap1 = (vel_tm < drp_end_no_td) && (d_vel_tm_td > drp_end_td);
                if(drm_end_td>2*R && drp_end_td<2*R && ~interv_ovlap)
                    integ_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,vel_td);
                    t1 = (2/(pi*vel_td))*integ_1;
                    prob_hf_p(i) = 1-t1;
                elseif(drm_end_td<2*R && drp_end_td<2*R && interv_ovlap)
                    rd_limit_dp_td = -(2*vel_td*vel_tm + 2*vel_td*vel_tp + 2*vel_tm*vel_tp - (R^4 - 2*R^2*rm^2 - 2*R^2*vel_td^2 - 4*R^2*vel_td*vel_tm - 2*R^2*vel_tm^2 + rm^4 - 2*rm^2*vel_td^2 - 4*rm^2*vel_td*vel_tm - 2*rm^2*vel_tm^2 + 4*rp^2*vel_td^2 + 8*rp^2*vel_td*vel_tm + 4*rp^2*vel_tm^2 + vel_td^4 + 4*vel_td^3*vel_tm + 6*vel_td^2*vel_tm^2 + 4*vel_td*vel_tm^3 + vel_tm^4)^(1/2) + R^2 - rm^2 + vel_td^2 + vel_tm^2)/(2*(vel_td + vel_tm));
                    rd_limit13 = -(2*vel_tm*vel_tp + R^2 - rm^2 + vel_tm^2 - (R^4 - 2*R^2*rm^2 - 2*R^2*vel_tm^2 + rm^4 - 2*rm^2*vel_tm^2 + 4*rp^2*vel_tm^2 + vel_tm^4)^(1/2))/(2*vel_tm);
                    drp_end_rd_td = ((rp^2-R^2)/(vel_tp + rd_limit_dp_td))-(vel_tp + rd_limit_dp_td);
                    integ_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,vel_td);
                    integ_2 = quad(@(rd) my_puehf3(R,rm,vel_tm,rd),0,vel_td);
                    integ_3 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,rp-R-vel_tp);
                    t1 = (2/(pi*vel_td))*integ_1;
                    t2 = (2/(pi*vel_td))*integ_2;
                    t3 = (2/(pi*vel_td))*atan(drp_end_td/sqrt(4*R^2-drp_end_td^2))*(vel_td-(rd_limit_dp_td));
                    t5 = (2/(pi*vel_td))*atan(drm_end_td/sqrt(4*R^2-drm_end_td^2))*(vel_td-(rd_limit_dp_td));
                    t4  = (1/vel_td)*((R-rm-vel_tm));
                    t6 = (1/vel_td)*(vel_td-(rp-R-vel_tp));
                    t7 = (2/(pi*vel_td))*integ_3;
                    t8  = (1/vel_td)*(R-rm-vel_tm);
                    t9 = (2/(pi*vel_td))*atan(drp_end_td/sqrt(4*R^2-drp_end_td^2))*(vel_td-(rd_limit_dp_td));
                    if(t1>t2)
                        prob_hf_p(i) = 0;
                    else
                        prob_hf_p(i) = t2 - t1;
                    end
                elseif(drm_end_no_td<2*R && drp_end_no_td<2*R && interv_ovlap)
                    rd_limit_dp_td = -(2*vel_td*vel_tm + 2*vel_td*vel_tp + 2*vel_tm*vel_tp - (R^4 - 2*R^2*rm^2 - 2*R^2*vel_td^2 - 4*R^2*vel_td*vel_tm - 2*R^2*vel_tm^2 + rm^4 - 2*rm^2*vel_td^2 - 4*rm^2*vel_td*vel_tm - 2*rm^2*vel_tm^2 + 4*rp^2*vel_td^2 + 8*rp^2*vel_td*vel_tm + 4*rp^2*vel_tm^2 + vel_td^4 + 4*vel_td^3*vel_tm + 6*vel_td^2*vel_tm^2 + 4*vel_td*vel_tm^3 + vel_tm^4)^(1/2) + R^2 - rm^2 + vel_td^2 + vel_tm^2)/(2*(vel_td + vel_tm));
                    rd_limit13 = -(2*vel_tm*vel_tp + R^2 - rm^2 + vel_tm^2 - (R^4 - 2*R^2*rm^2 - 2*R^2*vel_tm^2 + rm^4 - 2*rm^2*vel_tm^2 + 4*rp^2*vel_tm^2 + vel_tm^4)^(1/2))/(2*vel_tm);
                    integ_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,vel_td);
                    integ_2 = quad(@(rd) my_puehf3(R,rm,vel_tm,rd),0,vel_td);
                    integ_3 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,rp-R-vel_tp);
                    t1 = (2/(pi*vel_td))*integ_1;
                    t2 = (2/(pi*vel_td))*integ_2;
                    t3 = (2/(pi*vel_td))*atan(drp_end_td/sqrt(4*R^2-drp_end_td^2))*(vel_td-(rd_limit_dp_td));
                    t5 = (2/(pi*vel_td))*atan(drm_end_td/sqrt(4*R^2-drm_end_td^2))*(vel_td-(rd_limit_dp_td));
                    t4  = (1/vel_td)*(vel_td-(R-rm-vel_tm));
                    t6 = (1/vel_td)*(vel_td-(rp-R-vel_tp));
                    t7 = (2/(pi*vel_td))*integ_3;
                    t8  = (1/vel_td)*(R-rm-vel_tm);
                    prob_hf_p(i) = t8 + t2 - t1;
                elseif(drm_end_td<2*R && drp_end_td<2*R && ~interv_ovlap)
                    integ_1 = quad(@(rd) my_puehf2(R,rp,vel_tp,rd),0,vel_td);
                    integ_2 = quad(@(rd) my_puehf3(R,rm,vel_tm,rd),0,vel_td);
                    t1 = (2/(pi*vel_td))*integ_1;
                    t2 = (2/(pi*vel_td))*integ_2;
                    if(t1>t2)
                        prob_hf_p(i) = 0;
                    else
                        prob_hf_p(i) = t2 - t1;
                    end
                else
                    prob_hf_p(i) = 0;
                end
            end
        elseif(vel_tm+vel_td>2*sqrt(R^2-rm^2))
            if(vel_tp+vel_td>=sqrt(rp^2-rm^2)-sqrt(R^2-rm^2))
                rd_limit = (sqrt(-8*R^2+8*rp^2+vel_tm^2-2*vel_tm*vel_tp+vel_tp^2)-3*vel_tp-vel_tm)/4;
                d_vel_tm_td = vel_tm+vel_td;
                drm_end_td = ((R^2-rm^2)/(vel_tm+vel_td))+(vel_tm+vel_td);
                drm_end_no_td = ((R^2-rm^2)/(vel_tm))+(vel_tm);
                drp_end_td = ((rp^2-R^2)/(vel_tp + vel_td))-(vel_tp + vel_td);
                drp_end_no_td = ((rp^2-R^2)/(vel_tp))-(vel_tp);
                % to checlk if vel_tm_td regions overlap with d_rp_regions%
                cond_d_vel_tmtd_max = vel_tm > drp_end_no_td;
                cond_d_rp_max1 = d_vel_tm_td < drp_end_td;
                interv_ovlap1 = (vel_tm < drp_end_no_td) && (d_vel_tm_td > drp_end_td);
                if(cond_d_vel_tmtd_max && ~interv_ovlap1)
                    t1 = (2/(pi*vel_td))*atan(sqrt(R^2-rm^2)/rm)*(2*sqrt(R^2-rm^2)-vel_tm);
                    integ_1 = quad(@(rd) mynho5(R,vel_tm,rd),0,2*sqrt(R^2-rm^2)-vel_tm);
                    t2 = (2/(pi*vel_td))*integ_1;
                    prob_hf_p(i) = t1 - t2;
                else
                    prob_hf_p(i) = 0; %check point to check if any other condition satisfies%
                end
            end
        else
            prob_hf_p(i)=0;
            prob_pp(i)=0;
        end
        
    end
    prob_hf_p_set(j,:)=prob_hf_p;
    %   prob_pp_set(j,:)=prob_pp;
end
figure;
plot(v_km,prob_hf_p_set(1,:),v_km,prob_hf_p_set(2,:),v_km,prob_hf_p_set(3,:));
title('probability of PUE HF');
legend(['T_d = ',num2str(T_d(1)*1e3),' ms'],['T_d = ',num2str(T_d(2)*1e3),' ms'],['T_d = ',num2str(T_d(3)*1e3),' ms']);
% figure;
% plot(v,prob_pp_set(1,:),v,prob_pp_set(2,:),v,prob_pp_set(3,:),v,prob_pp_set(4,:));
% title('probability of PP');
% legend(['T_d = ',num2str(T_d(1)*3600*1e3),' ms'],['T_d =
% ',num2str(T_d(2)*3600*1e3),' ms'],['T_d = ',num2str(T_d(3)*3600*1e3),' ms'],['T_d = ',num2str(T_d(4)*3600*1e3),' ms']);